/*  create_result.c

  ࠡ⪠ ᪮쪨 䠩 csv  祭 ।
  ⢥ ⪮  ।񭭮 /⮫.
  Version 0.8

  Copyright 2017 Konstantin Zyryanov <post.herzog@gmail.com>
  
  This file is part of CSV parcing program.
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation; either version 2.1 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.
  
  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301, USA.
*/

//~ #include <stdio.h>
//~ #include <string.h>
//~ #include <stdlib.h>
//~ 
//~ struct files{
	//~ FILE *temp_file;
	//~ struct files *next;
//~ };
//~ 
//~ // , ᮤঠ ⠭  䠩 ப,
//~ //뫪  ᫥    ᨢ ᫮ 祭  ப,
//~ //  ࠡ뢠 䠩
//~ struct rawdata{
	//~ char *name[2000];
	//~ struct rd *next;
	//~ int values[];
//~ };

#include "csv_parcing.h"

int open_files(char **raw_files, const char *extension, int quantity, struct files **filePtr);
int open_file(FILE **opened_file, char *filename, const char *extension, const char *mode);
void close_files(struct files **filePtr);

int create_result(char **raw_files, int quantity, const char *extension)
{
	struct files *filePtr=NULL;
	int result=0;
	if (!strcmp(extension, ".adat"))
		result = open_files(raw_files, ".tdat", quantity, &filePtr);
	if (!strcmp(extension, ".csv"))
		result = open_files(raw_files, ".adat", quantity, &filePtr);
	if (result)
	{
		return result;
	}
	struct rawdata *data=NULL;
	struct rawdata *curdataPtr=NULL;
	if (filePtr)
	{
		struct files *curfilePtr=filePtr;
		int files_count=0; //६   ⢠  ६ 䠩
		while (curfilePtr)
		{
			files_count++;
			curfilePtr=curfilePtr->next;
		}
		if (!(data=calloc(1, sizeof(struct rawdata)+files_count*sizeof( int ))))
		{
			perror("஡   - ⠭ ࠡ⪨");
			return 2;
		}
		char *temp_string=calloc(2000, 1);
		curfilePtr=filePtr;
		curdataPtr=data;
		while (!(feof(curfilePtr->temp_file)))
		{
			curfilePtr=filePtr;
			for (int i=0; i < files_count; i++)
			{
				int before_separator=0;
				int offset=0;
				//ࠡ⪠ ⢫ ⮫쪮  砥 ᯥ譮 樨 뢠 ப  䠩
				if (fgets(temp_string, 2000, curfilePtr->temp_file))
				{
					if (temp_string[0] == '\"')
					{
						offset=1;
						int quote_count=1;
						do
						{
							before_separator++;
							if (temp_string[before_separator] == '\"')
								quote_count++;
						}
						while (strncmp(&temp_string[before_separator], TMP_SEP, 1) || quote_count%2);
						//~ strncpy(data->name, &temp_string[1], before_separator-2);
					}
					else
					{
						before_separator=strcspn(temp_string, TMP_SEP);
						//~ strncpy(data->name, temp_string, before_separator-1);
					}
					// 室 (ப   )
					if (curdataPtr->name[0] == '\000')
					{
						strncpy(curdataPtr->name, &temp_string[offset], before_separator-2*offset);
						curdataPtr->values[i]=atoi(&temp_string[before_separator+1]);
					}
					else	
					{
						//᫨ ⠭ ப  ⫨砥  㦥 ᠭ   -  ᨢ    祭
						int difference=strncmp(&temp_string[offset], curdataPtr->name, before_separator-2*offset);
						if (!difference)
						{
							curdataPtr->values[i]=atoi(&temp_string[before_separator+1]);
						}
						//᫨ ⠭ ப  ᠭ   - ᮧ  ,
						//᫥  ᯨ᪥, ᮤঠ  ப   祭
						else if (difference > 0)
						{
							struct rawdata *new=NULL;
							if (!(new=calloc(1, sizeof(struct rawdata)+files_count*sizeof( int ))))
							{
								perror("஡   - ⠭ ࠡ⪨");
								return 2;
							}
							strncpy(new->name, &temp_string[offset], before_separator-2*offset);
							new->values[i]=atoi(&temp_string[before_separator+1]);
							//᫨ ⥪  - ᫥  ᯨ᪥,
							//       ᯨ᪠
							if (!curdataPtr->next)
								curdataPtr->next=new;
							else
							{
								struct rawdata *tempcurPtr=curdataPtr->next;
								struct rawdata *tempprevPtr=curdataPtr;
								int diff2=strncmp(&temp_string[offset], tempcurPtr->name, before_separator-2*offset);
								while (diff2 > 0 && tempcurPtr->next)
								{
									tempprevPtr=tempcurPtr;
									tempcurPtr=tempcurPtr->next;
									diff2=strncmp(&temp_string[offset], tempcurPtr->name, before_separator-2*offset);
								}
								//᫨  ப , 祬   ᫥ ,
								//     ᠬ  ᯨ᪠
								if (diff2 > 0)
									tempcurPtr->next=new;
								//᫨  ப ᮢ  ப    ᫥  -
								// 祭   ᨢ ⠪ , ᠬ   㤠
								if (!diff2)
								{
									tempcurPtr->values[i]=new->values[i];
									free(new);
								}
								//᫨  ப , 祬    ᫥  -
								//  ⠢ । 
								if (diff2 < 0)
								{
									tempprevPtr->next=new;
									new->next=tempcurPtr;
								}
							}
						}
						//᫨ ⠭ ப  ᠭ   - ᮧ  ,
						//ᮤঠ  ப   祭,   ᯨ᪥ । ⥪饩 ன
						else if (difference < 0)
						{
							struct rawdata *new=NULL;
							if (!(new=calloc(1, sizeof(struct rawdata)+files_count*sizeof( int ))))
							{
								perror("஡   - ⠭ ࠡ⪨");
								return 2;
							}
							strncpy(new->name, &temp_string[offset], before_separator-2*offset);
							new->values[i]=atoi(&temp_string[before_separator+1]);
							//᫨ ⥪  - ࢠ  ᯨ᪥,
							//      砫 ᯨ᪠
							if (curdataPtr == data)
							{
								new->next=curdataPtr;
								data=new;
								curdataPtr=new;
							}
							else
							{
								struct rawdata *tempcurPtr=data;
								struct rawdata *tempprevPtr=data;
								int diff2=strncmp(&temp_string[offset], tempcurPtr->name, before_separator-2*offset);
								while (diff2 > 0 && tempcurPtr->next)
								{
									tempprevPtr=tempcurPtr;
									tempcurPtr=tempcurPtr->next;
									diff2=strncmp(&temp_string[offset], tempcurPtr->name, before_separator-2*offset);
								}
								//᫨  ப , 祬    ।  -
								// ⠢ । 
								if (diff2 < 0)
								{
									new->next=tempcurPtr;
									//᫨  ப  ப  ᠬ ࢮ  -
									//  ⠭ ࢮ  ᯨ᪥
									if (tempcurPtr == data)
										data=new;
									else
										tempprevPtr->next=new;
								}
								//᫨  ப ᮢ  ப    ᫥  -
								// 祭   ᨢ ⠪ , ᠬ   㤠
								if (!diff2)
								{
									tempcurPtr->values[i]=new->values[i];
									free(new);
								}
							}
						}
					}
					//~ curdataPtr->values[i]=atoi(&temp_string[before_separator+1]);
					
					//DEBUG
					//~ puts("");
					//~ printf("(%d) %s%s\n%d\n%s%d\n", i, temp_string, curdataPtr->name, before_separator, &temp_string[before_separator+1], curdataPtr->values[i]);
					
					memset(temp_string, 0, 2000);
					//᫨ ⨣  䠩 - ⢫  㣮 䠩  ᯨ᪥,
					// ண   ⨣
					//᫨ ⠪ 䠩  ( 䠩 ⠭  ) -
					//६ ᢠ  㪠⥫  ᫥ 㯭  ᯨ᪥ 䠩
					if (feof(curfilePtr->temp_file))
					{
						for (int j=0; j< files_count; j++)
						{
							if (!curfilePtr->next)
								curfilePtr=filePtr;
							else
								curfilePtr=curfilePtr->next;
							if (!(feof(curfilePtr->temp_file)))
							{
								i=j;
								break;
							}
						}
					}
					//᫨  䠩  ⨣ - ⢫ 室  ᫥饬 䠩
					else
						curfilePtr=curfilePtr->next;
					if (!curfilePtr)
						curfilePtr=filePtr;
				}
				//᫨ ⨣  䠩 - ⢫  㣮 䠩  ᯨ᪥,
				// ண   ⨣
				//᫨ ⠪ 䠩  ( 䠩 ⠭  ) -
				//६ ᢠ  㪠⥫  ᫥ 㯭  ᯨ᪥ 䠩
				if (feof(curfilePtr->temp_file))
				{
					for (int j=0; j< files_count; j++)
					{
						if (!curfilePtr->next)
							curfilePtr=filePtr;
						else
							curfilePtr=curfilePtr->next;
						if (!(feof(curfilePtr->temp_file)))
						{
							i=j;
							break;
						}
					}
				}
			}
			if (curdataPtr->next)
			{
				curdataPtr=curdataPtr->next;
			}
		}
		free(temp_string);
		temp_string=NULL;
		//DEBUG
		//~ struct rawdata *testdata=data;
		//~ puts("");
		//~ while (testdata)
		//~ {
			//~ printf("%s\n", testdata->name);
			//~ for (int i=0; i < files_count; i++)
			//~ {
				//~ printf("%d ", testdata->values[i]);
			//~ }
			//~ puts("");
			//~ testdata=testdata->next;
		//~ }
		
		//⨥ 㦥 䠩
		// 뢠    () ᫥饣 䠩   ࠡ⠭ 
		//(᫨ 㦥 䠩   -  㤥 ᮧ )
		FILE *dat_file=NULL;
		result=open_file(&dat_file, DATA_FILE, NULL, "r");
		if (result)
		{
			int string_lenght_1=strlen(" ஡  ⨨ 㦥 䠩 \n ");
			int string_lenght_2=strlen(DATA_FILE);
			char *error_message=calloc(string_lenght_1+string_lenght_2*2+1, 1);
			snprintf(error_message, string_lenght_1+string_lenght_2+1, " ஡  ⨨ 䠩 \"%s\"\n %s", DATA_FILE, DATA_FILE);
			if (!(dat_file = fopen(DATA_FILE, "w")))
			{
				perror(error_message);
				free(error_message);
				close_files(&filePtr);
				return 3;
			}
			fprintf(dat_file, "last_temp_file 0\n");
			fprintf(dat_file, "last_average_file 0\n");
			fprintf(dat_file, "last_result_file 0\n");
			fclose(dat_file);
			if (!(dat_file = fopen(DATA_FILE, "r")))
			{
				perror(error_message);
				free(error_message);
				close_files(&filePtr);
				return 3;
			}
			free(error_message);
			error_message=NULL;
		}
		char *tmp_filename=calloc(100, 1);
		char temp_string_2[18]={""};
		int lenght_string_2=0;
		do
		{
			fgets(tmp_filename, 100, dat_file);
			if (!strcmp(extension, ".adat"))
			{
				strncpy(temp_string_2, "last_average_file", 17);
				lenght_string_2=17;
			}
			if (!strcmp(extension, ".csv"))
			{
				strncpy(temp_string_2, "last_result_file", 16);
				lenght_string_2=16;
			}
			if (!strncmp(tmp_filename, temp_string_2, lenght_string_2))
			{
				int before_separator=strcspn(tmp_filename, " ");
				if (before_separator < strlen(tmp_filename))
				{
					char *temp_string=calloc(strlen(tmp_filename)-before_separator, 1);
					strncpy(temp_string, &tmp_filename[before_separator], strlen(tmp_filename));
					memset(tmp_filename, 0, 100);
					strncpy(tmp_filename, temp_string, strlen(temp_string));
					//TODO: ।  strtol
					int tmp_name=atoi(tmp_filename);
					tmp_name++;
					memset(tmp_filename, 0, 100);
					snprintf(tmp_filename, 100, "%d%s", tmp_name, extension);
					free(temp_string);
					temp_string=NULL;
					break;
				}
			}
		} while (!feof(dat_file));
		if (fclose(dat_file))
		{
			perror("訡 ࠡ⪨ ⥬ 䠩");
			return 3;
		}
		//⨥ ६ 䠩,    ᠭ १ । ᫥
		FILE *result_file=NULL;
		open_file(&result_file, tmp_filename, extension, "w");
		// । 祭
		if (!strcmp(extension, ".adat"))
		{
			struct rawdata *curdataPtr=data;
			while (curdataPtr)
			{
				int length=strlen(curdataPtr->name);
				if (strcspn(curdataPtr->name, TMP_SEP) < length || strcspn(curdataPtr->name, "\"") < length)
				{
					fprintf(result_file, "\"");
					fprintf(result_file, "%s\"%s", curdataPtr->name, TMP_SEP);
				}
				else
					fprintf(result_file, "%s%s", curdataPtr->name, TMP_SEP);
				int count=0;
				int res_value=0;
				for (int i=0; i< files_count; i++)
				{
					if (curdataPtr->values[i])
						count++;
					res_value=res_value+curdataPtr->values[i];
				}
				fprintf(result_file, "%d\n", count ? res_value/count : 0);
				curdataPtr=curdataPtr->next;
			}
		}
		// ᪮஢ । 祭
		if (!strcmp(extension, ".csv"))
		{
			struct rawdata *curdataPtr=data;
			while (curdataPtr)
			{
				int length=strlen(curdataPtr->name);
				if (strcspn(curdataPtr->name, TMP_SEP) < length || strcspn(curdataPtr->name, "\"") < length)
				{
					fprintf(result_file, "\"");
					fprintf(result_file, "%s\"", curdataPtr->name);
				}
				else
					fprintf(result_file, "%s", curdataPtr->name);
				for (int i=0; i<files_count; i++)
				{
					fprintf(result_file, "%s%d", TMP_SEP, curdataPtr->values[i]);
				}
				fputs("\n", result_file);
				curdataPtr=curdataPtr->next;
			}
		}
		//⨥  ᮧ 䠩 १   ⥬ 䠩
		if (fclose(result_file))
		{
			perror("訡  ६ 䠩");
			puts("஢ ࠢ 㯠  ⠫  ணࠬ  ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
			return 3;
		}
		dat_file=NULL;
		char *backup_filename=calloc(strlen(DATA_FILE)+strlen(".bak")+1,1);
		snprintf(backup_filename, strlen(DATA_FILE)+strlen(".bak")+1, "%s.bak", DATA_FILE);
		if (rename(DATA_FILE, backup_filename))
		{
			perror("訡 ࠡ⪨ ⥬ 䠩");
			puts("஢ ࠢ 㯠  ⠫  ணࠬ  ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
			free(backup_filename);
			return 3;
		}
		FILE *tmp;
		tmp=NULL;
		if (!(tmp = fopen(backup_filename, "r")))
		{
			perror("訡 ࠡ⪨ ⥬ 䠩");
			puts("஢ ࠢ 㯠  ⠫  ணࠬ  ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
			free(backup_filename);
			return 3;
		}
		if (!(dat_file = fopen(DATA_FILE, "w")))
		{
			perror("訡 ࠡ⪨ ⥬ 䠩");
			puts("஢ ࠢ 㯠  ⠫  ணࠬ  ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
			free(backup_filename);
			fclose(tmp);
			return 3;
		}
		temp_string=calloc(100, 1);
		while (!feof(tmp))
		{
			fgets(temp_string, 100, tmp);
			if ((!strncmp(temp_string, temp_string_2, lenght_string_2)) && !feof(tmp))
			{
				fprintf(dat_file, "%s %d\n", temp_string_2, atoi(&temp_string[lenght_string_2])+1);
				continue;
			}
			if (!feof(tmp))
				fprintf(dat_file, "%s", temp_string);
		}
		free(temp_string);
		temp_string=NULL;
		fclose(tmp);
		tmp=NULL;
		if (remove(backup_filename))
		{
			perror("訡 㤠 ६ ⥬ 䠩");
		}
		free(backup_filename);
		backup_filename=NULL;
		if (fclose(dat_file))
		{
			perror("訡  ⥬ 䠩");
			puts("஢ ࠢ 㯠  ⠫  ணࠬ  ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
			return 3;
		}
		printf("ࠡ⪠ 襭.  ᠭ  䠩: %s\n", tmp_filename);
		free(tmp_filename);
		tmp_filename=NULL;
	}
	//⨥ ६ 䠩
	if (filePtr)
	{
		close_files(&filePtr);
	}
	if (data)
	{
		struct rawdata *lastPtr=data;
		while (lastPtr)
		{
			data=data->next;
			free(lastPtr);
			lastPtr=data;
		}
	}
	return 0;
}
