/*  create_tdat.c

  ࠡ⪠ ᪮쪨 䠩 csv  祭 ।
  ⢥ ⪮  ।񭭮 /⮫.
  Version 0.8

  Copyright 2017 Konstantin Zyryanov <post.herzog@gmail.com>
  
  This file is part of CSV parcing program.
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation; either version 2.1 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.
  
  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301, USA.
*/

//~ #include <stdlib.h>
//~ #include <stdio.h>
//~ #include <string.h>
//~ #include <ctype.h>
//~ 
//~ //  ⥬ 䠩, ࠭饣  ᫥ ࠡ⠭ ६ 䠩
//~ #define DATA_FILE "files.dat"
//~ //⥫, ᯮ㥬  ६ 䠩
//~ //( ᨬ  ⮣,  ࠧ⥫  ᯮ짮  室 䠩)
//~ #define TMP_SEP ","
//~ 
//~ //  易 ᯨ᪠ ࠧ  ࠧ
//~ //ᯮ  ࠭ 祭    ࠡ⪨    䠩
//~ struct sections{
		//~ char sec_name[2000];
		//~ int sec_value;
		//~ struct sections *next;
//~ };

#include "csv_parcing.h"
#include <ctype.h>

int print_name(const char *category, char *temp_string, const char separator[0], const int offset, struct sections **section);
int count(const char *category, char *temp_string, const char separator[0], const int offset);
int next_element(struct sections **sectionPtr, const char *sec_name);

int create_temp_file(const char *price_filename)
{
	printf("ࠡ⪠ 䠩 \"%s\"...\n", price_filename);
	//⨥ 䠩
	FILE *price_file=NULL;
	int string_lenght_1=strlen(" ஡  ⨨ 䠩 \n ");
	int string_lenght_2=strlen(price_filename);
	char *error_message=calloc(string_lenght_1+string_lenght_2*2+1, 1);
	snprintf(error_message, string_lenght_1+string_lenght_2+1, " ஡  ⨨ 䠩 \"%s\"\n %s", price_filename, price_filename);
	if (!(price_file = fopen(price_filename, "r")))
	{
		perror(error_message);
		puts("室  ᫥饬 䠩...");
		free(error_message);
		return 1;
	}
	free(error_message);
	error_message=NULL;
	//⨥ 㦥 䠩,   뢠 ଠ  ᫥ ࠡ⠭ 䠩
	//(᫨ 㦥 䠩   -  㤥 ᮧ)
	FILE *dat_file=NULL;
	string_lenght_1=strlen(" ஡  ⨨ 㦥 䠩 \n ");
	string_lenght_2=strlen(DATA_FILE);
	error_message=calloc(string_lenght_1+string_lenght_2*2+1, 1);
	snprintf(error_message, string_lenght_1+string_lenght_2+1, " ஡  ⨨ 䠩 \"%s\"\n %s", DATA_FILE, DATA_FILE);
	//᫨ ⥬ 䠩  㤠   ⥭ - 믮 ⪠  ᮧ,
	//᫥ 祣 㤥 ᭮ ।ਭ ⪠    ०  ⥭
	if (!(dat_file = fopen(DATA_FILE, "r")))
	{
		if (!(dat_file = fopen(DATA_FILE, "w")))
		{
			perror(error_message);
			free(error_message);
			fclose(price_file);
			return 3;
		}
		fprintf(dat_file, "last_temp_file 0\n");
		fprintf(dat_file, "last_average_file 0\n");
		fprintf(dat_file, "last_result_file 0\n");
		fclose(dat_file);
		if (!(dat_file = fopen(DATA_FILE, "r")))
		{
			perror(error_message);
			free(error_message);
			fclose(price_file);
			return 3;
		}
	}
	char *tmp_filename=calloc(100, 1);
	do
	{
		fgets(tmp_filename, 100, dat_file);
		if (!strncmp(tmp_filename, "last_temp_file", 14))
		{
			int before_separator=strcspn(tmp_filename, " ");
			if (before_separator < strlen(tmp_filename))
			{
				char *temp_string=calloc(strlen(tmp_filename)-before_separator, 1);
				strncpy(temp_string, &tmp_filename[before_separator], strlen(tmp_filename));
				memset(tmp_filename, 0, 100);
				strncpy(tmp_filename, temp_string, strlen(temp_string));
				//TODO: ।  strtol
				int tmp_name=atoi(tmp_filename);
				tmp_name++;
				memset(tmp_filename, 0, 100);
				snprintf(tmp_filename, 100, "%d.%s", tmp_name, "tdat");
				free(temp_string);
				temp_string=NULL;
				break;
			}
		}
	} while (!feof(dat_file));
	free(error_message);
	error_message=NULL;
	if (!strncmp(tmp_filename, "", 1))
		strncpy(tmp_filename, "1.tdat", 6);
	//⨥ ६ 䠩,    뢠 ஬ १ ⮢
	FILE *temp_file=NULL;
	//~ char *tmp_filename=calloc(strlen(price_filename)+strlen(".tmp")+1,1);
	//~ snprintf(tmp_filename, strlen(price_filename)+strlen(".tmp")+1, "%s.tmp", price_filename);
	string_lenght_1=strlen(" ஡  ⨨ ६ 䠩 \n ");
	error_message=calloc(string_lenght_1+1, 1);
	snprintf(error_message, string_lenght_1+1, " ஡  ⨨ ६ 䠩 \"%s\"\n %s", tmp_filename, tmp_filename);
	if ((temp_file = fopen(tmp_filename, "r")))
	{
		char answer[10];
		printf(" 䠩 㦥  ࠡ⠭ - த 㭨⮦    .\nத ࠡ [Y/n]? ");
		fgets(answer, 10, stdin);
		if (!strncmp(answer, "n", 1) || !strncmp(answer, "N", 1) || !strncmp(answer, "no", 2) \
		 || !strncmp(answer, "No", 2) || !strncmp(answer, "NO", 2) || \
		  !strncmp(answer, "", 2) || !strncmp(answer, "", 2) || !strncmp(answer, "", 6) \
		  || !strncmp(answer, "", 6) || !strncmp(answer, "", 6))
		{
			free(error_message);
			free(tmp_filename);
			fclose(dat_file);
			fclose(temp_file);
			fclose(price_file);
			return 0;
		}
		fclose(temp_file);
		temp_file=NULL;
	}
	if (!(temp_file = fopen(tmp_filename, "w")))
	{
		perror(error_message);
		puts("஢ ࠢ 㯠  ⠫  ணࠬ  ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
		free(error_message);
		fclose(dat_file);
		free(tmp_filename);
		fclose(price_file);
		return 3;
	}
	//~ free(tmp_filename);
	free(error_message);
	//~ tmp_filename=NULL;
	error_message=NULL;
	char *category=calloc(2000, 1);
	if (!category)
	{
		puts("஡    ६ ⥭ 䠩 ࠩ");
		fclose(price_file);
		fclose(temp_file);
		return 2;
	}
	//筥 ᨬ ࠧ⥫ (','  ';' - ࠧ   ࠭  ࠧ)
	//~ char separator[0]=0;
	char separator[2]={0};
	while (!separator[0] && !feof(price_file))
	{
		//।⥫쭮, 2000 ᨬ  墠  ப  ࠩ
		//(ᠬ  祭 ப 﫠  ~380 ਫ᪨ ᨬ,  ࠢ ~760 ⠬)
		fgets(category, 2000, price_file);
		//᫨   ᨬ ப -   㭪樨  ⠡樨 -  ⠥ ࠧ⥫ﬨ
		//TODO:    ப/᫮/ᨬ  ࠢ
		if (((ispunct(category[0]) && ispunct(category[1]) && ispunct(category[2]) && ispunct(category[3])) && \
		((category[0] == category[1]) && (category[1] == category[2]) && (category[2] == category[3]))) || \
		((category[0] == '\t') && (category[1] == '\t') && (category[2] == '\t') && (category[3] == '\t')))
		{
			separator[0]=category[0];
		}
	}
	if (!separator[0])
	{
		puts("   䠩 - ஡  ࠧ⥫ﬨ");
		puts("ন ⮫쪮 䠩  ࠧ⥫ﬨ ','  ';'");
		free(category);
		category=NULL;
		fclose(dat_file);
		fclose(price_file);
		fclose(temp_file);
		// ६ 䠩,   䫨⮢   ᫥ ᪠  㣨 묨
		remove(tmp_filename);
		free(tmp_filename);
		tmp_filename=NULL;
		return 1;
	}
	free(tmp_filename);
	tmp_filename=NULL;
	//᭮ 横
	char *temp_string=calloc(2000, 1);
	if (!temp_string)
	{
		puts("஡    ६ ⥭ 䠩 ࠩ");
		free(category);
		category=NULL;
		fclose(dat_file);
		fclose(price_file);
		fclose(temp_file);
		return 2;
	}
	struct sections *catPtr=NULL;
	struct sections *subPtr=NULL;
	struct sections *last_subPtr=NULL;
	int cat_count=0; //稪  ⥣਩
	int sub_count=-1; //稪  ⥣਩; ⥫쭠 樠  砩 ⢨ ⥣ਨ
	int unit_count=0; //騩 稪   権
	while (!feof(price_file))
	{
		memset(category, 0, 2000);
		memset(temp_string, 0, 2000);
		struct sections *last_sectionPtr=NULL;
		fgets(category, 2000, price_file);
		int offset=0;
		// ᯮ짮  ⢥ ࠧ⥫ ',' ⠫  ࠬ   窨 -
		//᪫砥   ࠢ
		if (category[0] == '"')
			offset++;
		//  ࠧ  蠡 "ࠖࠒ窠஡"
		if (isdigit(category[offset]) && isdigit(category[offset+1]) && category[offset+2] == '.' && category[offset+3] == ' ')
		{
			if (cat_count)
			{
				if (sub_count > 0)
				{
					//~ printf("(%d 権  㯯)\n", sub_count);
					//᫨ ᫥ 㯯  㤥 ᮤঠ 㯯 -  稪 㤥 ᪫  
					sub_count=-1;
				}
				//~ printf("(%d 権  㯯)\n", cat_count);
				cat_count=0;
			}
			if (catPtr)
			{
				int length=strlen(catPtr->sec_name);
				//ࠡ⪠ ࠧ⥫ (/窨  ⮩)  祪   㯯  㯯
				if (strcspn(catPtr->sec_name, TMP_SEP) < length || strcspn(catPtr->sec_name, "\"") < length)
				{
					fprintf(temp_file, "\"");
					fprintf(temp_file, "%s\"%s", catPtr->sec_name, TMP_SEP);
					fprintf(temp_file, "%d\n", catPtr->sec_value);
				}
				else
					fprintf(temp_file, "%s%s%d\n", catPtr->sec_name, TMP_SEP, catPtr->sec_value);
				memset(catPtr, 0, sizeof(struct sections));
				free(catPtr);
				catPtr=NULL;
				last_subPtr=NULL;
				if (subPtr)
				{
					last_sectionPtr=subPtr;
					while (last_sectionPtr)
					{
						length=strlen(last_sectionPtr->sec_name);
						if (strcspn(last_sectionPtr->sec_name, TMP_SEP) < length || strcspn(last_sectionPtr->sec_name, "\"") < length)
						{
							fprintf(temp_file, "\"");
							fprintf(temp_file, "%s\"%s", last_sectionPtr->sec_name, TMP_SEP);
							fprintf(temp_file, "%d\n", last_sectionPtr->sec_value);
						}
						else
							fprintf(temp_file, "%s%s%d\n", last_sectionPtr->sec_name, TMP_SEP, last_sectionPtr->sec_value);
						last_sectionPtr=last_sectionPtr->next;
						memset(subPtr, 0, sizeof(struct sections));
						free(subPtr);
						subPtr=last_sectionPtr;
					}
				}
			}
				
			if (print_name(category, temp_string, &separator[0], offset, &catPtr))
				return 2;
			continue;
		}
		//  ࠧ  蠡 "ࠖࠒ窠ࠖࠏ஡"
		if (isdigit(category[offset]) && isdigit(category[offset+1]) && category[offset+2] == '.' && isdigit(category[offset+3]) && isdigit(category[offset+4]) && category[offset+5] == ' ')
		{
			//᫨ 稪  ࠭ ᪫ - 頥   ன
			if (sub_count < 0)
				sub_count=0;
			if (sub_count)
			{
				//~ printf("(%d 権  㯯)\n", sub_count);
				sub_count=0;
			}
			if (print_name(category, temp_string, &separator[0], offset, &subPtr))
				return 2;
			last_sectionPtr=subPtr;
			while (last_sectionPtr->next)
			{
				last_sectionPtr=last_sectionPtr->next;
			}
			last_subPtr=last_sectionPtr;
			continue;
		}
		// ᫥饩 ୮ 樨  
		// 室  砫 ப  ᮤন ⮫쪮 
		int before_separator=0;
		long int unit_code=0; // ।饭 ९  砩 祭 ᨫ쭮 襩 
		before_separator=strcspn(&category[offset], &separator[0]);
		if (before_separator)
		{
			char *tile_string=calloc(2000, 1);
			strncpy(temp_string, &category[offset], before_separator);
			// ८ࠧ: ᭠砫  long int, ⥬ १ - ⭮  ப
			//᫨ 砫쭠  筠 ப ᮢ - ८ࠧ 諮 ᯥ譮,
			// (ᮮ⢥⢥,  ப  ன) 
			// ⨢ 砥 ⢫ 室  ᫥襩 ப
			unit_code=strtol(temp_string, NULL, 10);
			snprintf(tile_string, 2000, "%li", unit_code);
			if (strcmp(temp_string, tile_string))
			{
				// 室 訡  砥 宦 , 稭  
				//(ਬ "0060"  "00-00001270")
				//᫨   ࠭ ᫥⥫쭮 ᨬ  祣 ஬   ,
				// ᫥⥫쭮 ⠥ ⢨⥫ 
				// ⨢ 砥 ६ unit_code ᢠ ⥫쭮 祭  横 뢠
				for (int i=0; i<strlen(temp_string); i++)
				{
					if (!(isdigit(temp_string[i])) && temp_string[i] != '-')
					{
						free(tile_string);
						tile_string=NULL;
						//~ continue;
						unit_code=-1;
						break;
					}
				}
				//FIXME:  室 ᠭ  ஡ ( १ । ८ࠧ
				//祭 ६ unit_code ࠢ "0")
				if (unit_code < 0)
					unit_code=0;
				else if (!unit_code)
					unit_code=1;
			}
			free(tile_string);
			tile_string=NULL;
		}
		//᫨  ⮢  - ࠡ⪠ ப த
		if (unit_code)
		{
			//~ if (unit_code == 60886)
				//~ puts("!");
			// ⪮
			//TODO: ७  ன
			int value_col=6;
			for (int i=1; i < value_col-1; i++) //  㦥 ன,  砫  ⪮
			{
				//~ printf("%s\n", &category[before_separator]);
				//ࠡ⪠ ,   ࠧ⥫ﬨ (⥪  ⠪ 묨 ࠬ 묨 窠)
				if (category[before_separator+1] == '\"')
				{
					// ᨬ  뢠饩 窨,
					//⥬ ਡ  ᫥ 뢠饩 窨  ᨬ ࠧ⥫ (⮩)
					int quote_count=0;
					do
					{
						before_separator++;
						if (category[before_separator] == '\"')
							quote_count++;
						//᫨     ப - 室  ᫥ ப  ࠭ ⥪饣 ﭨ
						if (category[before_separator] =='\n')
						{
							memset(category, 0, 2000);
							fgets(category, 2000, price_file);
							before_separator=0;
							//~ printf("%s\n", &category[before_separator]);
						}
					}
					// 室  த "Some ""THING"" " (᪮쪮 祪  (।⥫쭮, )
					while (category[before_separator] != separator[0] || quote_count%2);
				}
				else
				{
					before_separator=before_separator+strcspn(&category[before_separator+1], &separator[0])+1; // ᫥ ࠧ⥫
					// 室 ⭮ 訡  "ᬥ" ࠧ⥫  㭪樨   ஡
					//(    ।饩  ।।饩 樨   ப)
					//FIXME:  稭 訡, ᫨  - ࠢ
					if (category[before_separator] != separator[0])
					{
						do
						{
							before_separator++;
						}
						while (category[before_separator] != separator[0]);
					}
				}
			}
			if (category[before_separator+1] == '\"')
				offset=1;
			else
				offset=0;
			// ⢥ ⪮   ப  ।騬
			int value=0;
			value=count(&category[before_separator+1], temp_string, &separator[0], offset);
			unit_count=unit_count+value;
			//  稪 ⥣਩ ந ⮫쪮 ᫨ 稪   ࠭ ᪫  ⮢
			//( 砥 ⢨ 㯯   =㯯 ⮢஢)
			if (sub_count >= 0)
				sub_count=sub_count+value;
			cat_count=cat_count+value;
			catPtr->sec_value=catPtr->sec_value+value;
			if (last_subPtr)
				last_subPtr->sec_value=last_subPtr->sec_value+value;
		}
	}
	// १ ந ⮫쪮 ᫨ 稪     ᪫
	if (sub_count > 0)
		//~ printf("(%d 権  㯯)\n", sub_count);
	//~ printf("(%d 権  㯯)\n", cat_count);
	//~ printf("ࠡ⪠ 䠩 襭 (\"%s\")\nᥣ %d 権\n", price_filename, unit_count);
	printf("ࠡ⪠ 䠩 襭 (\"%s\")\nᥣ %d 権\n", price_filename, unit_count);
	free(category);
	category=NULL;
	//~ catPtr->sec_value=catPtr->sec_value+value;
	int length=strlen(catPtr->sec_name);
	if (strcspn(catPtr->sec_name, TMP_SEP) < length || strcspn(catPtr->sec_name, "\"") < length)
	{
		fprintf(temp_file, "\"");
		fprintf(temp_file, "%s\"%s", catPtr->sec_name, TMP_SEP);
		fprintf(temp_file, "%d\n", catPtr->sec_value);
	}
	else
		fprintf(temp_file, "%s%s%d\n", catPtr->sec_name, TMP_SEP, catPtr->sec_value);
	memset(catPtr, 0, sizeof(struct sections));
	free(catPtr);
	catPtr=NULL;
	if (subPtr)
	{
		struct sections *last_sectionPtr=NULL;
		last_sectionPtr=subPtr;
		while (last_sectionPtr)
		{
			length=strlen(last_sectionPtr->sec_name);
			if (strcspn(last_sectionPtr->sec_name, TMP_SEP) < length || strcspn(last_sectionPtr->sec_name, "\"") < length)
			{
				fprintf(temp_file, "\"");
				fprintf(temp_file, "%s\"%s", last_sectionPtr->sec_name, TMP_SEP);
				fprintf(temp_file, "%d\n", last_sectionPtr->sec_value);
			}
			else
				fprintf(temp_file, "%s%s%d\n", last_sectionPtr->sec_name, TMP_SEP, last_sectionPtr->sec_value);
			last_sectionPtr=last_sectionPtr->next;
			memset(subPtr, 0, sizeof(struct sections));
			free(subPtr);
			subPtr=last_sectionPtr;
		}
	}
	fclose(price_file);
	if (fclose(temp_file))
	{
		perror("訡  ६ 䠩");
		puts("஢ ࠢ 㯠  ⠫  ணࠬ  ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
		return 3;
	}
	if (fclose(dat_file))
	{
		perror("訡 ࠡ⪨ ⥬ 䠩");
		free(temp_string);
		fclose(temp_file);
		return 3;
	}
	dat_file=NULL;
	char *backup_filename=calloc(strlen(DATA_FILE)+strlen(".bak")+1,1);
	snprintf(backup_filename, strlen(DATA_FILE)+strlen(".bak")+1, "%s.bak", DATA_FILE);
	if (rename(DATA_FILE, backup_filename))
	{
		perror("訡 ࠡ⪨ ⥬ 䠩");
		puts("஢ ࠢ 㯠  ⠫  ணࠬ  ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
		free(backup_filename);
		free(temp_string);
		fclose(temp_file);
		return 3;
	}
	FILE *tmp;
	tmp=NULL;
	if (!(tmp = fopen(backup_filename, "r")))
	{
		perror("訡 ࠡ⪨ ⥬ 䠩");
		puts("஢ ࠢ 㯠  ⠫  ணࠬ  ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
		free(backup_filename);
		free(temp_string);
		fclose(temp_file);
		return 3;
	}
	if (!(dat_file = fopen(DATA_FILE, "w")))
	{
		perror("訡 ࠡ⪨ ⥬ 䠩");
		puts("஢ ࠢ 㯠  ⠫  ணࠬ  ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
		free(backup_filename);
		free(temp_string);
		fclose(tmp);
		fclose(temp_file);
		return 3;
	}
	while (!feof(tmp))
	{
		fgets(temp_string, 100, tmp);
		if ((!strncmp(temp_string, "last_temp_file", 14)) && !feof(tmp))
		{
			fprintf(dat_file, "last_temp_file %d\n", atoi(&temp_string[14])+1);
			printf(" ᠭ  䠩: %d.tdat\n", atoi(&temp_string[14])+1);
			continue;
		}
		if (!feof(tmp))
			fprintf(dat_file, "%s", temp_string);
	}
	free(temp_string);
	temp_string=NULL;
	fclose(tmp);
	tmp=NULL;
	if (remove(backup_filename))
	{
		perror(error_message);
	}
	free(backup_filename);
	backup_filename=NULL;
	if (fclose(dat_file))
	{
		perror("訡  ⥬ 䠩");
		puts("஢ ࠢ 㯠  ⠫  ணࠬ  ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
		fclose(temp_file);
		return 3;
	}
	return 0;
}

//뢮  ⥣ਨ/⥣ਨ
//TODO: ॠ 뢮  䠩
int print_name(const char *category, char *temp_string, const char separator[0], const int offset, struct sections **section)
{
	int length;
	// 뢮 ࠢ ⮫쪮 ॡ㥬 , ⠫ ᨬ  ப 뢠
	if (offset)
		length=strcspn(&category[offset], "\"");
	else
		length=strcspn(&category[offset], &separator[0]);
	strncpy(temp_string, &category[offset], length);
	temp_string[length]='\000';
	//~ printf("%s\n", temp_string);
	next_element(*(&section), temp_string);
	return 0;
}

//ࠡ⪠ ⢥ ⪮ - १ 譨 ᨬ  㤠 ஡  ࠬ
int count(const char *category, char *temp_string, const char separator[0], const int offset)
{
	int length;
	// 뢮 ࠢ ⮫쪮 ॡ㥬 , ⠫ ᨬ  ப 뢠
	if (offset)
		length=strcspn(&category[offset], "\"");
	else
		length=strcspn(&category[offset], &separator[0]);
	strncpy(temp_string, &category[offset], length);
	temp_string[length]='\000';
	// ஡  ࠬ
	for (int i=0; i<length; i++)
	{
		if (!isdigit(temp_string[i]) && temp_string[i] != '\000')
		{
			char *temp_space1=calloc(length, 1);
			char *temp_space2=calloc(length, 1);
			strncpy(temp_space1, temp_string, i);
			strncpy(temp_space2, &temp_string[i+1], length-i-1);
			memset(temp_string, 0, 2000);
			strncpy(temp_string, temp_space1, i);
			strcat(temp_string, temp_space2);
			free(temp_space1);
			free(temp_space2);
			temp_space1=NULL;
			temp_space2=NULL;
			i--;
		}
	}
	//~ printf("%s\n", temp_string);
	length=atoi(temp_string); //TODO:  ஢ ᯥ譮 ८ࠧ
	//~ printf("%d\n", length);
	return length;
}

//㭪     祭  易 ᯨ᮪ (ᨢ ) ࠧ/ࠧ
int next_element(struct sections **sectionPtr, const char *sec_name)
{
	struct sections *new_sectionPtr=NULL;
	if (!(new_sectionPtr=calloc(1, sizeof(struct sections))))
	{
		perror("஡   - ⠭ ࠡ⪨");
		return 2;
	}
	strcpy(new_sectionPtr->sec_name, sec_name);
	//~ new_sectionPtr->sec_value=value;
	new_sectionPtr->next=NULL;
	if (!(*sectionPtr))
		*sectionPtr=new_sectionPtr;
	else
	{
		struct sections *last_sectionPtr=NULL;
		last_sectionPtr=*sectionPtr;
		while (last_sectionPtr->next)
		{
			last_sectionPtr=last_sectionPtr->next;
		}
		last_sectionPtr->next=new_sectionPtr;
	}
	return 0;
}

//஢ઠ ࠬ஢,  짮⥫
//㭪 頥  񭭮 짮⥫ 祭,  "-2"  ⢥ 訡
//ࠡ⪠ ४⭮ ।⢥ ᠬ 祭 ந  ஢ ࠡ⪨ ࠬ஢
short int parameters_check(const char *parameter_name, const char *parameter_value, const short int default_value, const short int *parameter)
{
	//  祭, ॢ ࠧ short int,  ⠪  ᫮ ᨬ
	long int temp_int;
	char *tile_string[100]={""};
	temp_int=strtol(parameter_value, tile_string, 10);
	if ((!temp_int) && (parameter_value == *tile_string))
	{
		printf("祭 '%s' ࠬ '%s' ⭮. ", parameter_value, parameter_name);
		if (*parameter == default_value)
			printf("⠭ 祭  㬮砭: %i.\n", default_value);
		else
			printf("祭   (%hi).\n", *parameter);
		return -2;
	}
	short int value=temp_int;
	//᫨  ࠬ । ஡ ᫮/ -
	//⠪ 祭  祭  楫 ᥫ/ࠢ  㫨  祭  㬮砭
	char value_string[10]; // 10 c  㬥 筮 讥 ᫮
	snprintf(value_string, 10, "%hi", value);
	if (strcmp(value_string, parameter_value))
	{
		printf("祭 '%s' ࠬ '%s' ⭮. ", parameter_value, parameter_name);
		if (*parameter == default_value)
			printf("⠭ 祭  㬮砭: %i.\n", default_value);
		else
			printf("祭   (%hi).\n", *parameter);
		return -2;
	}
	return value;
}
