/*  help.c

  ࠡ⪠ ᪮쪨 䠩 csv  祭 ।
  ⢥ ⪮  ।񭭮 /⮫.
  Version 0.8

  Copyright 2017 Konstantin Zyryanov <post.herzog@gmail.com>
  
  This file is part of CSV parcing program.
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation; either version 2.1 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.
  
  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301, USA.
*/

//~ #include <stdio.h>
//~ #include <string.h>
#include "csv_parcing.h"

void print_help(const char *program_title, const int help_size)
{
	int line_length=strlen(program_title);
	int indent=0;
	
	//뢮 ଠ஢ ⪮ ࠢ ( ࠬ "-h")
	//᫥ ப ("[-h|--help]") ࠡ뢠  뢮 ⤥쭮,  ⠪ 㦨 ਧ  ᨢ
	char *help_strings[]={"[-o |--open ]",
						"[-a |--average ]",
						"[-c |--combine ]",
						"[-h|--help]"};
	printf("\n  ᯮ짮: \n\n%s", program_title);
	//஢ઠ  ᯮ짮 㯠   ப ਭ   ணࠬ
	//᫨  ணࠬ  ப  , 祬 80 (ਭ ନ+஡) - ⠭ 祭  㬮砭 (10)
	//᫥ ப ᨢ ("[-h|--help]")  ࠡ뢠 -  㤥 뢮  ⤥쭮 ப
	int i=0;
	while (strncmp(help_strings[i], "[-h", 3))
	{
		if (line_length+strlen(help_strings[i]) < 79)
			indent=line_length+1;
		else
			indent=10;
		i++;
	}
	i=0;
	while (strncmp(help_strings[i], "[-h", 3))
	{
		//᫨  ணࠬ  ࢮ ப ࠢ  80 (ਭ ନ+஡;   (㧭  㦥)?),
		// ࢠ ப ࠢ 뢮  ⮩  ப
		//FIXME: ୮ 뢠 ࠧ ਫ᪨ ᨬ!
		line_length=line_length+strlen(help_strings[i]);
		if (line_length < 79)
		{
			printf(" %s", help_strings[i]);
		}
		// - ந ॢ   ப  㯮  10 ஡  ⠭ ਧ ॢ ப
		else
		{
			printf("\n%*s%s", indent, " ", help_strings[i]);
			line_length=strlen(help_strings[i])+indent;
		}
		i++;
	}
	//᫥ ப ⪮ ࠢ ("[-h|--help]") 뢮  ⤥ ப
	printf("\n\n%s", program_title);
	if (strlen(program_title)+strlen(help_strings[i]) < 79)
	{
		printf(" %s", help_strings[i]);
	}
	else
	{
		printf("\n%*s%s", indent, " ", help_strings[i]);
	}
	printf("\n\n");

	//᫨ 㪠 ࠬ "--help" - ⥫쭮 뢮  ࠢ
	//TODO: ७   譥 䠩 
	if (help_size)
	{
		FILE *help_file=NULL;
		help_file=fopen("help.txt", "r");
		if (help_file == NULL)
		{
			puts(" ࠢ   ०");
			return;
		}
		//char printhelp[200];
		while (!feof(help_file) && !ferror(help_file))
		{
			char printhelp[200]={'\000'};
			fgets(printhelp, 200, help_file);
			printf("%s", printhelp);
		}
		fclose(help_file);
		//~ printf("\n\n");
	}
	return;
}
